"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from nws_api_client.types import BaseModel
from typing import List, Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


class TypeMultiPolygon(str, Enum):
    MULTI_POLYGON = "MultiPolygon"


class GeoJSONMultiPolygonTypedDict(TypedDict):
    coordinates: List[List[List[List[float]]]]
    type: TypeMultiPolygon
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONMultiPolygon(BaseModel):
    coordinates: List[List[List[List[float]]]]

    type: TypeMultiPolygon

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class TypeMultiLineString(str, Enum):
    MULTI_LINE_STRING = "MultiLineString"


class GeoJSONMultiLineStringTypedDict(TypedDict):
    coordinates: List[List[List[float]]]
    type: TypeMultiLineString
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONMultiLineString(BaseModel):
    coordinates: List[List[List[float]]]

    type: TypeMultiLineString

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class TypeMultiPoint(str, Enum):
    MULTI_POINT = "MultiPoint"


class GeoJSONMultiPointTypedDict(TypedDict):
    coordinates: List[List[float]]
    type: TypeMultiPoint
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONMultiPoint(BaseModel):
    coordinates: List[List[float]]

    type: TypeMultiPoint

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class TypePolygon(str, Enum):
    POLYGON = "Polygon"


class GeoJSONPolygonTypedDict(TypedDict):
    coordinates: List[List[List[float]]]
    r"""A GeoJSON polygon. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
    type: TypePolygon
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONPolygon(BaseModel):
    coordinates: List[List[List[float]]]
    r"""A GeoJSON polygon. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: TypePolygon

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class TypeLineString(str, Enum):
    LINE_STRING = "LineString"


class GeoJSONLineStringTypedDict(TypedDict):
    coordinates: List[List[float]]
    r"""A GeoJSON line string. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
    type: TypeLineString
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONLineString(BaseModel):
    coordinates: List[List[float]]
    r"""A GeoJSON line string. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: TypeLineString

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class TypePoint(str, Enum):
    POINT = "Point"


class GeoJSONPointTypedDict(TypedDict):
    coordinates: List[float]
    r"""A GeoJSON coordinate. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
    type: TypePoint
    bbox: NotRequired[List[float]]
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


class GeoJSONPoint(BaseModel):
    coordinates: List[float]
    r"""A GeoJSON coordinate. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: TypePoint

    bbox: Optional[List[float]] = None
    r"""A GeoJSON bounding box. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


GeoJSONGeometryTypedDict = TypeAliasType(
    "GeoJSONGeometryTypedDict",
    Union[
        GeoJSONPointTypedDict,
        GeoJSONLineStringTypedDict,
        GeoJSONPolygonTypedDict,
        GeoJSONMultiPointTypedDict,
        GeoJSONMultiLineStringTypedDict,
        GeoJSONMultiPolygonTypedDict,
    ],
)
r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""


GeoJSONGeometry = TypeAliasType(
    "GeoJSONGeometry",
    Union[
        GeoJSONPoint,
        GeoJSONLineString,
        GeoJSONPolygon,
        GeoJSONMultiPoint,
        GeoJSONMultiLineString,
        GeoJSONMultiPolygon,
    ],
)
r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
