"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .jsonldcontext_union import JSONLdContextUnion, JSONLdContextUnionTypedDict
from .metarphenomenon import MetarPhenomenon, MetarPhenomenonTypedDict
from .metarskycoverage import MetarSkyCoverage
from .quantitativevalue import QuantitativeValue, QuantitativeValueTypedDict
from datetime import datetime
from enum import Enum
from nws_api_client.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ObservationAtType(str, Enum):
    WX_OBSERVATION_STATION = "wx:ObservationStation"


class CloudLayerTypedDict(TypedDict):
    amount: MetarSkyCoverage
    base: QuantitativeValueTypedDict
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""


class CloudLayer(BaseModel):
    amount: MetarSkyCoverage

    base: QuantitativeValue
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""


class ObservationTypedDict(TypedDict):
    at_context: NotRequired[JSONLdContextUnionTypedDict]
    at_id: NotRequired[str]
    at_type: NotRequired[ObservationAtType]
    barometric_pressure: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    cloud_layers: NotRequired[Nullable[List[CloudLayerTypedDict]]]
    dewpoint: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    elevation: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    geometry: NotRequired[Nullable[str]]
    r"""A geometry represented in Well-Known Text (WKT) format."""
    heat_index: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    icon: NotRequired[Nullable[str]]
    max_temperature_last24_hours: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    min_temperature_last24_hours: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    precipitation_last3_hours: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    precipitation_last6_hours: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    precipitation_last_hour: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    present_weather: NotRequired[List[MetarPhenomenonTypedDict]]
    raw_message: NotRequired[str]
    relative_humidity: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    sea_level_pressure: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    station: NotRequired[str]
    temperature: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    text_description: NotRequired[str]
    timestamp: NotRequired[datetime]
    visibility: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    wind_chill: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    wind_direction: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    wind_gust: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""
    wind_speed: NotRequired[QuantitativeValueTypedDict]
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""


class Observation(BaseModel):
    at_context: Annotated[
        Optional[JSONLdContextUnion], pydantic.Field(alias="@context")
    ] = None

    at_id: Annotated[Optional[str], pydantic.Field(alias="@id")] = None

    at_type: Annotated[Optional[ObservationAtType], pydantic.Field(alias="@type")] = (
        None
    )

    barometric_pressure: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="barometricPressure")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    cloud_layers: Annotated[
        OptionalNullable[List[CloudLayer]], pydantic.Field(alias="cloudLayers")
    ] = UNSET

    dewpoint: Optional[QuantitativeValue] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    elevation: Optional[QuantitativeValue] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    geometry: OptionalNullable[str] = UNSET
    r"""A geometry represented in Well-Known Text (WKT) format."""

    heat_index: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="heatIndex")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    icon: Annotated[
        OptionalNullable[str],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = UNSET

    max_temperature_last24_hours: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="maxTemperatureLast24Hours")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    min_temperature_last24_hours: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="minTemperatureLast24Hours")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    precipitation_last3_hours: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="precipitationLast3Hours")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    precipitation_last6_hours: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="precipitationLast6Hours")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    precipitation_last_hour: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="precipitationLastHour")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    present_weather: Annotated[
        Optional[List[MetarPhenomenon]], pydantic.Field(alias="presentWeather")
    ] = None

    raw_message: Annotated[Optional[str], pydantic.Field(alias="rawMessage")] = None

    relative_humidity: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="relativeHumidity")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    sea_level_pressure: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="seaLevelPressure")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    station: Optional[str] = None

    temperature: Optional[QuantitativeValue] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    text_description: Annotated[
        Optional[str], pydantic.Field(alias="textDescription")
    ] = None

    timestamp: Optional[datetime] = None

    visibility: Optional[QuantitativeValue] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    wind_chill: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="windChill")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    wind_direction: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="windDirection")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    wind_gust: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="windGust")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    wind_speed: Annotated[
        Optional[QuantitativeValue], pydantic.Field(alias="windSpeed")
    ] = None
    r"""A structured value representing a measurement and its unit of measure. This object is a slighly modified version of the schema.org definition at https://schema.org/QuantitativeValue"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "@context",
            "@id",
            "@type",
            "barometricPressure",
            "cloudLayers",
            "dewpoint",
            "elevation",
            "geometry",
            "heatIndex",
            "icon",
            "maxTemperatureLast24Hours",
            "minTemperatureLast24Hours",
            "precipitationLast3Hours",
            "precipitationLast6Hours",
            "precipitationLastHour",
            "presentWeather",
            "rawMessage",
            "relativeHumidity",
            "seaLevelPressure",
            "station",
            "temperature",
            "textDescription",
            "timestamp",
            "visibility",
            "windChill",
            "windDirection",
            "windGust",
            "windSpeed",
        ]
        nullable_fields = ["cloudLayers", "geometry", "icon"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
