"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import date
from nws_api_client.models.components import (
    sigmetcollectiongeojson as components_sigmetcollectiongeojson,
)
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, QueryParamMetadata
import pydantic
from typing import Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetSigmetsRequestTypedDict(TypedDict):
    start: NotRequired[str]
    r"""Start time"""
    end: NotRequired[str]
    r"""End time"""
    date_: NotRequired[date]
    r"""Date (YYYY-MM-DD format)"""
    atsu: NotRequired[str]
    r"""ATSU identifier"""
    sequence: NotRequired[str]
    r"""SIGMET sequence number"""


class GetSigmetsRequest(BaseModel):
    start: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Start time"""

    end: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""End time"""

    date_: Annotated[
        Optional[date],
        pydantic.Field(alias="date"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Date (YYYY-MM-DD format)"""

    atsu: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""ATSU identifier"""

    sequence: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""SIGMET sequence number"""


class GetSigmetsResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: components_sigmetcollectiongeojson.SigmetCollectionGeoJSONTypedDict


class GetSigmetsResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: components_sigmetcollectiongeojson.SigmetCollectionGeoJSON
